
package main;

import Connection.ConnectionDB;
import com.formdev.flatlaf.FlatLightLaf;
import com.formdev.flatlaf.intellijthemes.FlatArcDarkIJTheme;
import com.formdev.flatlaf.intellijthemes.FlatDarkFlatIJTheme;
import com.formdev.flatlaf.intellijthemes.FlatLightFlatIJTheme;
import java.awt.Color;
import java.awt.Font;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.UIManager;

/**
 *
 * @author CHINDA
 */
public class LogIn extends javax.swing.JFrame {

    /**
     * Creates new form LogIn
     */
    public LogIn() {
        initComponents();
        addPlaceHolder(txtPassword);
        try {
            ConnectionDB.connectionDB("localhost:3306", "myhome", "root", "Chinda1234$");
            getUser();
            ConnectionDB.getDataCon().close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnEnter = new javax.swing.JButton();
        txtPassword = new javax.swing.JPasswordField();
        chb = new javax.swing.JCheckBox();
        cmb = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("LogIn");
        setResizable(false);
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }
            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        btnEnter.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        btnEnter.setText("Enter");
        btnEnter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEnterActionPerformed(evt);
            }
        });

        txtPassword.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        txtPassword.setText("password");
        txtPassword.setEchoChar('\u0000');
        txtPassword.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtPasswordFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                txtPasswordFocusLost(evt);
            }
        });
        txtPassword.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtPasswordKeyTyped(evt);
            }
        });

        chb.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N
        chb.setText("show your password");
        chb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chbActionPerformed(evt);
            }
        });

        cmb.setFont(new java.awt.Font("Khmer OS Battambang", 1, 12)); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(113, 113, 113)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(111, 111, 111)
                        .addComponent(btnEnter, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(txtPassword)
                        .addComponent(chb, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(cmb, javax.swing.GroupLayout.PREFERRED_SIZE, 184, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(118, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(112, Short.MAX_VALUE)
                .addComponent(cmb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(chb)
                .addGap(17, 17, 17)
                .addComponent(btnEnter)
                .addGap(44, 44, 44))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnEnterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEnterActionPerformed
        String user = cmb.getSelectedItem().toString();
        String pass = String.valueOf(txtPassword.getPassword());
        logIn(user, pass);
    }//GEN-LAST:event_btnEnterActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
        this.requestFocusInWindow();
    }//GEN-LAST:event_formWindowGainedFocus

    private void txtPasswordFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtPasswordFocusGained
        String pass = String.valueOf(txtPassword.getPassword());
        if(pass.equals("password")){
            removePlaceHolder(txtPassword);
            if(chb.isSelected())
                txtPassword.setEchoChar('\u0000');
            else
                txtPassword.setEchoChar('*');
        }
    }//GEN-LAST:event_txtPasswordFocusGained

    private void txtPasswordFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtPasswordFocusLost
        String pass = String.valueOf(txtPassword.getPassword());
        if(pass.equals("")){
            addPlaceHolder(txtPassword);
            txtPassword.setEchoChar('\u0000');
            txtPassword.setText("password");
        }
    }//GEN-LAST:event_txtPasswordFocusLost

    private void chbActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chbActionPerformed
       if(chb.isSelected())
           txtPassword.setEchoChar('\u0000');
       else{
           String pass = String.valueOf(txtPassword.getPassword());
           if(!pass.equals("password"))
               txtPassword.setEchoChar('*');
       }
    }//GEN-LAST:event_chbActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        
        
    }//GEN-LAST:event_formWindowOpened

    private void txtPasswordKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtPasswordKeyTyped
        if(evt.getKeyChar()==10){
            String user = cmb.getSelectedItem().toString();
            String pass = String.valueOf(txtPassword.getPassword());
            logIn(user, pass);
        }
            
    }//GEN-LAST:event_txtPasswordKeyTyped
    private void getUser()throws Exception{
        Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
        ResultSet rs = s.executeQuery("select distinct user from information_schema.USER_ATTRIBUTES");
        while(rs.next())
            cmb.addItem(rs.getString(1));
        rs.close();
        s.close();
        
    }
    private void logIn(String user , String pass){
        try{ 
            ConnectionDB.connectionDB("localhost:3306", "myhome", user, pass);
            this.dispose();
            Wedding.main(null);
        }catch(Exception e){
            JOptionPane.showMessageDialog(this,"Incorrect Password");
        }
    }
    private void addPlaceHolder(JTextField txt){
        Font font = txt.getFont();
        font = font.deriveFont(Font.PLAIN);
        txt.setFont(font);
        txt.setForeground(Color.GRAY);
    
  }
    private void removePlaceHolder(JTextField txt){
        Font font = txt.getFont();
        font = font.deriveFont(Font.BOLD);
        txt.setFont(font);
        txt.setForeground(Color.BLACK);
        txt.setText(null);
  }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        try {
            UIManager.setLookAndFeel(new FlatLightLaf());
        } catch (Exception e) {
        }
       
//        t
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(LogIn.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(LogIn.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(LogIn.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(LogIn.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LogIn().setVisible(true);
            }
        });
    }
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnEnter;
    private javax.swing.JCheckBox chb;
    private javax.swing.JComboBox<String> cmb;
    private javax.swing.JPasswordField txtPassword;
    // End of variables declaration//GEN-END:variables
}
